<template>
    <div class="container">
        <div class="content">
            <div class="control-bar font-size-xbig">
                <div class="control-buttons">
                    <span @click="handlePreviousClick()" class="margin-right-normal">
                        <b-icon class="ink-lighter-1">
                            <icon-chevron-left />
                        </b-icon>
                    </span>
                    <span @click="handleNextClick()">
                        <b-icon class="ink-lighter-1">
                            <icon-chevron-right />
                        </b-icon>
                    </span>
                </div>

                <span class="semi-bold">{{images[currentIndex].title}}</span>

                <span @click="$emit('onClose')" class="close-button margin-left-big">
                    <b-icon class="ink-lighter-1">
                        <icon-clear />
                    </b-icon>
                </span>
            </div>
            
            <img :src="images[currentIndex].url" :alt="images[currentIndex].title" class="image">
        </div>
    </div>
</template>

<script>
import BIcon from '@/dls/components/Icon.vue';
import IconChevronLeft from '@/dls/icons/icon-chevron-left.svg';
import IconChevronRight from '@/dls/icons/icon-chevron-right.svg';
import IconClear from '@/dls/icons/icon-clear.svg';

export default {
    name: 'b-lightbox',
    components: {
        BIcon,
        IconChevronLeft,
        IconChevronRight,
        IconClear,
    },
    props: {
        /*
        * Array de imagens. Ex: [{ title: 'Image', url: '...' }]
        */
        images: {
            type: Array,
            default: () => []
        },
        /*
        * Referência da imagem que foi clicada. Ex: 2
        */
        currentImageIndex: {
            type: Number,
            default: 0
        },
        /*
        * Classes customizadas do container. Ex: 'ink-lighter-1', 'semi-bold'
        */
        customClasses: {
            type: String,
            default: ''
        },
        /*
        * Estilos customizados do container. Ex: ''
        */
        customStyles: {
            type: String,
            default: ''
        },
    },
    data() {
        return {
            currentIndex: 0
        }
    },
    mounted() {
        this.currentIndex = this.currentImageIndex
    },
    methods: {
        handlePreviousClick() {
            this.currentIndex = (this.currentIndex + this.images.length - 1) % this.images.length
        },
        handleNextClick() {
            this.currentIndex = (this.currentIndex + 1) % this.images.length
        }
    }
}
</script>

<style scoped lang="scss">
.container {
    position: fixed;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: rgba(0,0,0,0.5);
    z-index: 9999;
    display: flex;
    align-items: center;
    justify-content: center;
}

.content {
    margin: 16px;
    padding: 8px;
    background-color: white;
    border-radius: 5px;
    display: flex;
    flex-direction: column;
}

.image {
    max-width: 100%;
    max-height: 75vh;
}

.control-bar {
    margin-bottom: 8px;
    display: flex;
    justify-content: space-between;
}

.control-buttons {
    cursor: pointer;
}
.close-button {
    cursor: pointer;
}
</style>

<docs>
    Lightbox
</docs>